datablock ParticleData(FordorSedanPoliceLightAParticle)
{
	dragCoefficient = 0.0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 1;
	lifetimeVarianceMS = 0;
	framesPerSec = 1;
	textureName = "./SirenFlare";
	colors[0] = "0.000000 0.000000 1.000000 1.000000";
	colors[1] = "0.000000 0.000000 1.000000 1.000000";
	sizes[0] = "4.0";
	sizes[1] = "4.0";
	times[0] = "0.0";
	times[1] = "1.0";

};

datablock ParticleEmitterData(FordorSedanPoliceLightAEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvances = false;
	particles = "FordorSedanPoliceLightAParticle";
};

datablock ParticleData(FordorSedanPoliceLightBParticle)
{
	dragCoefficient = 0.0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 1;
	lifetimeVarianceMS = 0;
	framesPerSec = 1;
	textureName = "./SirenFlare";
	colors[0] = "1.000000 0.000000 0.000000 1.000000";
	colors[1] = "1.000000 0.000000 0.000000 1.000000";
	sizes[0] = "4.0";
	sizes[1] = "4.0";
	times[0] = "0.0";
	times[1] = "1.0";
};

datablock ParticleEmitterData(FordorSedanPoliceLightBEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvances = false;
	particles = "FordorSedanPoliceLightBParticle";
};

datablock ShapeBaseImageData(FordorSedanPoliceLightAImage)
{
	shapeFile = "./BlueLights.dts";
	emap = false;

	mountPoint = 6;
	rotation = "0.0 0.0 0.0";
	offset = "0.0 0.0 0.0";

	stateName[0] = "Ready";
	stateEmitter[0] = FordorSedanPoliceLightAEmitter;
	stateEmitterTime[0] = 10000;
};

datablock ShapeBaseImageData(FordorSedanPoliceLightBImage)
{
	shapeFile = "./RedLights.dts";
	emap = false;

	mountPoint = 5;
	rotation = "0.0 0.0 0.0";
	offset = "0.0 0.0 0.0";

	stateName[0] = "Ready";
	stateEmitter[0] = FordorSedanPoliceLightBEmitter;
	stateEmitterTime[0] = 10000;
};






datablock WheeledVehicleSpring(FordorSedanSpring)
{
	length = 0.3;
	force = 7500;
	damping = 600;
	antiSwayForce = 3;
	
};

datablock WheeledVehicleTire(FordorSedanTire)
{
	shapeFile = "./fordortire.dts";

	mass = 10;
	radius = 1;
	staticFriction = 5;
	kineticFriction = 5;
	restitution = 0.5;	

	lateralForce = 18000;
	lateralDamping = 4000;
	lateralRelaxation = 0.01;

	longitudinalForce = 14000;
	longitudinalDamping = 2000;
	longitudinalRelaxation = 0.01;
};

datablock DebrisData(FordorSedanTireDebris)
{
	emitters = "JeepTireDebrisTrailEmitter";

	shapeFile = "./fordortire.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(FordorSedanExplosion : vehicleExplosion)
{
	debris = FordorSedanTireDebris;
	debrisNum = 4;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 40;
	debrisThetaMax = 85;
	debrisVelocity = 14;
	debrisVelocityVariance = 3;
};

datablock ProjectileData(FordorSedanExplosionProjectile : vehicleExplosionProjectile)
{
	directDamage = 0;
	radiusDamage = 0;
	damageRadius = 0;
	explosion = FordorSedanExplosion;

	directDamageType  = $DamageType::VehicleExplosion;
	radiusDamageType  = $DamageType::VehicleExplosion;

	explodeOnDeath = 1;

	armingDelay = 0;
	lifetime = 0;

	uiName = "";
};

datablock DebrisData(FordorSedanDebris)
{
	emitters = "JeepDebrisTrailEmitter";

	shapeFile = "./fordorWreck.dts";
	lifetime = 3.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 500.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock DebrisData(FordorSedanStretchDebris)
{
	emitters = "JeepDebrisTrailEmitter";

	shapeFile = "./fordorStretchWreck.dts";
	lifetime = 3.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 500.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock DebrisData(FordorConvertibleDebris)
{
	emitters = "JeepDebrisTrailEmitter";

	shapeFile = "./fordorConvertibleWreck.dts";
	lifetime = 3.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 500.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(FordorSedanFinalExplosion : vehicleFinalExplosion)
{
	debris = FordorSedanDebris;
	debrisNum = 1;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 20;
	debrisVelocity = 18;
	debrisVelocityVariance = 3;
};

datablock ExplosionData(FordorSedanStretchFinalExplosion : vehicleFinalExplosion)
{
	debris = FordorSedanStretchDebris;
	debrisNum = 1;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 20;
	debrisVelocity = 18;
	debrisVelocityVariance = 3;
};

datablock ExplosionData(FordorConvertibleFinalExplosion : vehicleFinalExplosion)
{
	debris = FordorConvertibleDebris;
	debrisNum = 1;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 20;
	debrisVelocity = 18;
	debrisVelocityVariance = 3;
};

datablock ProjectileData(FordorSedanFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage = 0;
   radiusDamage = 0;
   damageRadius = 0;
   explosion = FordorSedanFinalExplosion;

   directDamageType = $DamageType::VehicleExplosion;
   radiusDamageType = $DamageType::VehicleExplosion;

   explodeOnDeath = 1;

   armingDelay = 0;
   lifetime = 0;

   uiName = "";
};

datablock ProjectileData(FordorSedanStretchFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage = 0;
   radiusDamage = 0;
   damageRadius = 0;
   explosion = FordorSedanStretchFinalExplosion;

   directDamageType = $DamageType::VehicleExplosion;
   radiusDamageType = $DamageType::VehicleExplosion;

   explodeOnDeath = 1;

   armingDelay = 0;
   lifetime = 0;

   uiName = "";
};


datablock ProjectileData(FordorConvertibleFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage = 0;
   radiusDamage = 0;
   damageRadius = 0;
   explosion = FordorConvertibleFinalExplosion;

   directDamageType = $DamageType::VehicleExplosion;
   radiusDamageType = $DamageType::VehicleExplosion;

   explodeOnDeath = 1;

   armingDelay = 0;
   lifetime = 0;

   uiName = "";
};

datablock WheeledVehicleData(FordorSedanVehicle)
{
	category = "Vehicles";

	//- Render -
	shapeFile = "./Fordor.dts";
	emap = true;

	//- Physics -
	mass = 375;
	drag = 1.0;
	density = 5.0;

	//- Damage/Energy -
	maxEnergy = 100;
	maxDamage = 250;
	destroyedLevel = 240;
	isInvincible = false;

	//- Camera -
	useEyePoint = false;

	//- Vehicle Data -
	jetForce = 3000.0;
	jetEnergyDrain = 2.0;
	minJetEnergy = 30.0;
	massCenter = "0.0 0.0 0.0";
	massBox = "0.0 0.0 0.0";
	bodyRestitution = 0.6;
	bodyFriction = 0.6;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	minImpactSpeed = 10.0;
	softImpactSpeed = 10.0;
	hardImpactSpeed = 15.0;
	maxSteeringAngle = 0.9785;
	integration = 4;
	collisionTol = 0.1;
	contactTol = 0.01;
	cameraRoll = false;
	cameraLag = 0.0;
	cameraDecay = 0.75;
	cameraOffset = 7.5;
	cameraMaxDist = 10.0;
	cameraTilt = 0.4;
	damageEmitter[0] = vehicleBurnEmitter;
	damageEmitter[1] = vehicleBurnEmitter;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;
	damageLevelTolerance[1] = 1.0;
	numDmgEmitterAreas = 1.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.6;
	exitSplashSoundVelocity = 5.0;
	softSplashSoundVelocity = 0.0;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	uiName = "Fordor Sedan";
	rideAble = true;
	
	//- Wheeled Vehicle -
	maxWheelSpeed = 30.0;
	engineTorque = 10000.0;
	engineBrake = 4000.0;
	brakeTorque = 20000.0;
	rollForce =	900.0;
	yawForce = 600.0;
	pitchForce = 3000.0;
	rotationalDrag = 0.2;
	stallSpeed = 0.0;
	steeringUseAutoReturn = true;
	steeringAutoReturnRate = 0.9;
	steeringAutoReturnMaxSpeed = 10;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.1;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	tireEmitter = vehicleTireEmitter;

	//- Mounting -
	minMountDist = 3;
	numMountPoints = 4;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";

	//- Vehicle Damage -
	speedDamageScale = 1.04;
	collDamageMultiplier = 0.02;
	collDamageThresholdVel = 20.0;

	//- Passenger Protection -
	protectPassengersBurn = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;

	//- RunOver -
	minRunOverSpeed = 4.0;
	runOverDamageScale = 8.0;
	runOverPushScale = 1.2;

	//- Misc -
	defaultTire	= FordorSedanTire;
	defaultSpring = FordorSedanSpring;
	numWheels = 4;
	paintable = true;
	initialExplosionProjectile = FordorSedanExplosionProjectile;
	initialExplosionOffset = 0.0;
	finalExplosionProjectile = FordorSedanFinalExplosionProjectile;
	finalExplosionOffset = 0.5;
	burnTime = 4000;
	lookUpLimit = 0.5;
	lookDownLimit = 0.5;
};

datablock WheeledVehicleData(FordorSedanPoliceVehicle : FordorSedanVehicle)
{
	//- Vehicle Data -
	uiName = "Fordor Sedan Police";
	maxWheelSpeed = 36.0;
};

datablock WheeledVehicleData(FordorSedanTaxiVehicle : FordorSedanVehicle)
{
	//- Vehicle Data -
	uiName = "Fordor Sedan Taxi";
		maxWheelSpeed = 32.0;
};

datablock WheeledVehicleData(FordorSedanSportVehicle : FordorSedanVehicle)
{
	//- Vehicle Data -
	uiName = "Fordor Sedan Sport";
	maxWheelSpeed = 35.0;
};

datablock WheeledVehicleData(FordorSedanStretchVehicle : FordorSedanVehicle)
{
	category = "Vehicles";
	//- Render -
	shapeFile = "./FordorStretch.dts";
	emap = true;
	//- Vehicle Data -
	uiName = "Fordor Sedan Stretch";
	maxWheelSpeed = 28.0;
	//- Mounting -
	minMountDist = 3;
	numMountPoints = 8;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";
	mountThread[4] = "sit";
	mountThread[5] = "sit";
	mountThread[6] = "sit";
	mountThread[7] = "sit";
	finalExplosionProjectile = FordorSedanStretchFinalExplosionProjectile;
};

datablock WheeledVehicleData(FordorConvertibleVehicle : FordorSedanVehicle)
{
	category = "Vehicles";
	//- Render -
	shapeFile = "./FordorConvertible.dts";
	emap = true;
	//- Vehicle Data -
	uiName = "Fordor Convertible";
	finalExplosionProjectile = FordorConvertibleFinalExplosionProjectile;
};

function FordorSedanVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxiCheck);
	%this.hideNode(taxiLight);
	%this.hideNode(taxiLamp);
	%this.hideNode(policeWhite);
	%this.hideNode(SirenBlue);
	%this.hideNode(SirenRed);
	%this.hideNode(SirenWhite);
	%this.hideNode(Mesh);
	%this.hideNode(BPD);
	%this.hideNode(policeblack);
	%this.hideNode(policegear);
	%this.hideNode(policewall);
	%this.hideNode(sportkit);
	%this.hideNode(sportblack);
	
	parent::onAdd(%db,%this);
}

function FordorSedanPoliceVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxiCheck);
	%this.hideNode(taxiLight);
	%this.hideNode(taxiLamp);
    %this.unhideNode(policeWhite);
    %this.unhideNode(SirenBlue);
    %this.unhideNode(SirenRed);
    %this.unhideNode(SirenWhite);
    %this.unhideNode(Mesh);
    %this.unhideNode(BPD);
    %this.unhideNode(policeblack);
    %this.unhideNode(policegear);
    %this.unhideNode(policewall);
	%this.hideNode(sportkit);
	%this.hideNode(sportblack);
		
	if(!isObject(FordorSedanPoliceSirenSO))
		new ScriptObject(FordorSedanPoliceSirenSO);
	FordorSedanPoliceSirenSO.addCar(%this);
	
	parent::onAdd(%db,%this);
}

function FordorSedanTaxiVehicle::onAdd(%db,%this)
{
    %this.unhideNode(taxiCheck);
    %this.unhideNode(taxiLight);
    %this.unhideNode(taxiLamp);
	%this.hideNode(policeWhite);
	%this.hideNode(SirenBlue);
	%this.hideNode(SirenRed);
	%this.hideNode(SirenWhite);
	%this.hideNode(Mesh);
	%this.hideNode(BPD);
	%this.hideNode(policeblack);
	%this.hideNode(policegear);
    %this.unhideNode(policewall);
	%this.hideNode(sportkit);
	%this.hideNode(sportblack);
	%this.hideNode(RedSirens);
	
	parent::onAdd(%db,%this);
}

function FordorSedanSportVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxiCheck);
	%this.hideNode(taxiLight);
	%this.hideNode(taxiLamp);
	%this.hideNode(policeWhite);
	%this.hideNode(SirenBlue);
	%this.hideNode(SirenRed);
	%this.hideNode(SirenWhite);
	%this.hideNode(Mesh);
	%this.hideNode(BPD);
	%this.hideNode(policeblack);
	%this.hideNode(policegear);
	%this.hideNode(policewall);
	%this.hideNode(Fenders);
    %this.unhideNode(sportkit);
    %this.unhideNode(sportblack);
	
	parent::onAdd(%db,%this);
}





function FordorSedanPoliceSirenSO::addCar(%this,%obj)
{
	if(isObject(%obj))
		if(%obj.getDatablock() == FordorSedanPoliceVehicle.getID())
			%this.car[%this.carCount++ - 1] = %obj;
	if(%this.carCount == 1)
		%this.loop();
}

function FordorSedanPoliceSirenSO::removeCar(%this,%obj)
{
	for(%a = 0; %a < %this.carCount; %a++)
		if(%this.car[%a] == %obj)
			break;
	if(%a < %this.carCount)
		for(%b = %a; %b < %this.carCount; %b++)
			%this.car[%b] = %this.car[%b + 1];
}

function FordorSedanPoliceSirenSO::loop(%this)
{
	cancel(%this.loop);
	
	if(%this.carCount > 0)
	{
		%this.state++;
		if(%this.state > 3)
			%this.state = 0;
		
		for(%a = 0; %a < %this.carCount; %a++)
		{
			if(!isObject(%this.car[%a]))
				%this.removeCar(%this.car[%a]);
			else
			{
				switch(%this.state)
				{
					case 0:
						%this.car[%a].unmountImage(0);
						
					case 1:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(FordorSedanPoliceLightAImage,0);
					case 2:
						%this.car[%a].unmountImage(0);
					case 3:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(FordorSedanPoliceLightBImage,0);
				}
			}
		}
		
		%this.loop = %this.schedule(250,loop);
	}
	else
		%this.schedule(0,delete);
}





package Vehicle_FordorSedan
{
	function serverCmdLight(%client)
	{
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.player;
			%veh = %player.getControlObject();
			if(isObject(%veh))
				if(%veh.getDatablock() == FordorSedanPoliceVehicle.getID())
				{
					%veh.useSiren = !%veh.useSiren;
					return "";
				}
		}
		parent::serverCmdLight(%client);
	}
	function Vehicle::setNodeColor(%this,%node,%color)
	{
		parent::setNodeColor(%this,%node,%color);
		if(%this.getDatablock() == FordorSedanPoliceVehicle.getID() && %node $= "ALL")
		{
				%doorPanels = "0.96078431 0.96078431 0.96078431 1.0";
			%this.setNodeColor("doorpanels",%doorPanels);
				%body = "0.1254902 0.1254902 0.1254902 1.0";
			%this.setNodeColor("body",%body);
				%Fenders = "0.1254902 0.1254902 0.1254902 1.0";
			%this.setNodeColor("Fenders",%Fenders);
		}
		if(%this.getDatablock() == FordorSedanTaxiVehicle.getID() && %node $= "ALL")
		{
				%TdoorPanels = "1 0.75 0 1.0";
			%this.setNodeColor("doorpanels",%TdoorPanels);
				%body = "1 0.75 0 1.0";
			%this.setNodeColor("body",%body);
				%Fenders = "0.1254902 0.1254902 0.1254902 1.0";
			%this.setNodeColor("Fenders",%Fenders);
		}
	}
};
activatePackage(Vehicle_FordorSedan);